//
// Copyright 2021 Vulcanize, Inc.
//

import { Entity, PrimaryColumn, Column, Index } from 'typeorm';
import { decimalTransformer, bigintTransformer } from '@cerc-io/util';
import { Decimal } from 'decimal.js';

@Entity()
@Index(['blockNumber'])
export class UniswapDayData {
  @PrimaryColumn('varchar')
    id!: string;

  @PrimaryColumn('varchar', { length: 66 })
    blockHash!: string;

  @Column('integer')
    blockNumber!: number;

  @Column('integer')
    date!: number;

  @Column('numeric', { transformer: decimalTransformer })
    dailyVolumeETH!: Decimal;

  @Column('numeric', { transformer: decimalTransformer })
    dailyVolumeUSD!: Decimal;

  @Column('numeric', { transformer: decimalTransformer })
    dailyVolumeUntracked!: Decimal;

  @Column('numeric', { transformer: decimalTransformer })
    totalVolumeETH!: Decimal;

  @Column('numeric', { transformer: decimalTransformer })
    totalLiquidityETH!: Decimal;

  @Column('numeric', { transformer: decimalTransformer })
    totalVolumeUSD!: Decimal;

  @Column('numeric', { transformer: decimalTransformer })
    totalLiquidityUSD!: Decimal;

  @Column('numeric', { transformer: bigintTransformer })
    txCount!: bigint;

  @Column('boolean', { default: false })
    isPruned!: boolean;

  @Column('boolean', { default: false })
    isRemoved!: boolean;
}
