//
// Copyright 2021 Vulcanize, Inc.
//

import { Entity, PrimaryColumn, Column, Index } from 'typeorm';
import { bigintTransformer } from '@cerc-io/util';

@Entity()
@Index(['blockNumber'])
export class SetProtocolFeeEvent {
  @PrimaryColumn('varchar')
    id!: string;

  @PrimaryColumn('varchar', { length: 66 })
    blockHash!: string;

  @Column('integer')
    blockNumber!: number;

  @Column('varchar')
    pool!: string;

  @Column('numeric', { transformer: bigintTransformer })
    logIndex!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    new0!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    new1!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    old0!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    old1!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    timestamp!: bigint;

  @Column('boolean', { default: false })
    isPruned!: boolean;

  @Column('boolean', { default: false })
    isRemoved!: boolean;
}
